#' OpenAPI Petstore
#'
#' This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#'
#' The version of the OpenAPI document: 1.0.0
#' Generated by: https://openapi-generator.tech
#'

#' @docType class
#' @title Store operations
#' @description petstore.Store
#' @format An \code{R6Class} generator object
#' @field api_client Handles the client-server communication.
#'
#' @section Methods:
#' \describe{
#' \strong{ DeleteOrder } \emph{ Delete purchase order by ID }
#' For valid response try integer IDs with value &lt; 1000. Anything above 1000 or nonintegers will generate API errors
#'
#' \itemize{
#' \item \emph{ @param } order_id character
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 400 | Invalid ID supplied
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 404 | Order not found
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ GetInventory } \emph{ Returns pet inventories by status }
#' Returns a map of status codes to quantities
#'
#' \itemize{
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : map(integer) 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ GetOrderById } \emph{ Find purchase order by ID }
#' For valid response try integer IDs with value &lt;&#x3D; 5 or &gt; 10. Other values will generated exceptions
#'
#' \itemize{
#' \item \emph{ @param } order_id integer
#' \item \emph{ @returnType } \link{Order} \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : Order 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 400 | Invalid ID supplied
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 404 | Order not found
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ PlaceOrder } \emph{ Place an order for a pet }
#' 
#'
#' \itemize{
#' \item \emph{ @param } order \link{Order}
#' \item \emph{ @returnType } \link{Order} \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : Order 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 400 | Invalid Order
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' }
#'
#'
#' @examples
#' \dontrun{
#' ####################  DeleteOrder  ####################
#'
#' library(petstore)
#' var.order_id <- 'order_id_example' # character | ID of the order that needs to be deleted
#'
#' #Delete purchase order by ID
#' api.instance <- StoreApi$new()
#'
#'result <- tryCatch(
#'             api.instance$DeleteOrder(var.order_id),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  GetInventory  ####################
#'
#' library(petstore)
#'
#' #Returns pet inventories by status
#' api.instance <- StoreApi$new()
#'
#' #Configure API key authorization: api_key
#' api.instance$api_client$api_keys['api_key'] <- 'TODO_YOUR_API_KEY';
#'
#'result <- tryCatch(
#'             api.instance$GetInventory(),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  GetOrderById  ####################
#'
#' library(petstore)
#' var.order_id <- 56 # integer | ID of pet that needs to be fetched
#'
#' #Find purchase order by ID
#' api.instance <- StoreApi$new()
#'
#'result <- tryCatch(
#'             api.instance$GetOrderById(var.order_id),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  PlaceOrder  ####################
#'
#' library(petstore)
#' var.order <- Order$new() # Order | order placed for purchasing the pet
#'
#' #Place an order for a pet
#' api.instance <- StoreApi$new()
#'
#'result <- tryCatch(
#'             api.instance$PlaceOrder(var.order),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' }
#' @importFrom R6 R6Class
#' @importFrom base64enc base64encode
#' @importFrom rlang abort
#' @export
StoreApi <- R6::R6Class(
  "StoreApi",
  public = list(
    api_client = NULL,
    #' Initialize a new StoreApi.
    #'
    #' @description
    #' Initialize a new StoreApi.
    #'
    #' @param api_client An instance of API client.
    #' @export
    initialize = function(api_client) {
      if (!missing(api_client)) {
        self$api_client <- api_client
      }
      else {
        self$api_client <- ApiClient$new()
      }
    },
    #' Delete purchase order by ID
    #'
    #' @description
    #' Delete purchase order by ID
    #'
    #' @param order_id ID of the order that needs to be deleted
    #' @param ... Other optional arguments
    #' @return void
    #' @export
    DeleteOrder = function(order_id, ...) {
      api_response <- self$DeleteOrderWithHttpInfo(order_id, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Delete purchase order by ID
    #'
    #' @description
    #' Delete purchase order by ID
    #'
    #' @param order_id ID of the order that needs to be deleted
    #' @param ... Other optional arguments
    #' @return API response (void) with additional information such as HTTP status code, headers
    #' @export
    DeleteOrderWithHttpInfo = function(order_id, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`order_id`)) {
        rlang::abort(message = "Missing required parameter `order_id`.", .subclass = "ApiException", ApiException = ApiException$new(status = 0, reason = "Missing required parameter `order_id`."))
      }

      body <- NULL
      url_path <- "/store/order/{orderId}"
      if (!missing(`order_id`)) {
        url_path <- gsub(paste0("\\{", "orderId", "\\}"), URLencode(as.character(`order_id`), reserved = TRUE), url_path)
      }


      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "DELETE",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        ApiResponse$new(NULL, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Returns pet inventories by status
    #'
    #' @description
    #' Returns pet inventories by status
    #'
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return map(integer)
    #' @export
    GetInventory = function(data_file=NULL, ...) {
      api_response <- self$GetInventoryWithHttpInfo(data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Returns pet inventories by status
    #'
    #' @description
    #' Returns pet inventories by status
    #'
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (map(integer)) with additional information such as HTTP status code, headers
    #' @export
    GetInventoryWithHttpInfo = function(data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      body <- NULL
      url_path <- "/store/inventory"
      # API key authentication
      if ("api_key" %in% names(self$api_client$api_keys) && nchar(self$api_client$api_keys["api_key"]) > 0) {
        header_params["api_key"] <- paste(unlist(self$api_client$api_keys["api_key"]), collapse = "")
      }

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "GET",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "map(integer)", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response", .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Find purchase order by ID
    #'
    #' @description
    #' Find purchase order by ID
    #'
    #' @param order_id ID of pet that needs to be fetched
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return Order
    #' @export
    GetOrderById = function(order_id, data_file=NULL, ...) {
      api_response <- self$GetOrderByIdWithHttpInfo(order_id, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Find purchase order by ID
    #'
    #' @description
    #' Find purchase order by ID
    #'
    #' @param order_id ID of pet that needs to be fetched
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (Order) with additional information such as HTTP status code, headers
    #' @export
    GetOrderByIdWithHttpInfo = function(order_id, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`order_id`)) {
        rlang::abort(message = "Missing required parameter `order_id`.", .subclass = "ApiException", ApiException = ApiException$new(status = 0, reason = "Missing required parameter `order_id`."))
      }

      body <- NULL
      url_path <- "/store/order/{orderId}"
      if (!missing(`order_id`)) {
        url_path <- gsub(paste0("\\{", "orderId", "\\}"), URLencode(as.character(`order_id`), reserved = TRUE), url_path)
      }


      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "GET",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "Order", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response", .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Place an order for a pet
    #'
    #' @description
    #' Place an order for a pet
    #'
    #' @param order order placed for purchasing the pet
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return Order
    #' @export
    PlaceOrder = function(order, data_file=NULL, ...) {
      api_response <- self$PlaceOrderWithHttpInfo(order, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Place an order for a pet
    #'
    #' @description
    #' Place an order for a pet
    #'
    #' @param order order placed for purchasing the pet
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (Order) with additional information such as HTTP status code, headers
    #' @export
    PlaceOrderWithHttpInfo = function(order, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`order`)) {
        rlang::abort(message = "Missing required parameter `order`.", .subclass = "ApiException", ApiException = ApiException$new(status = 0, reason = "Missing required parameter `order`."))
      }

      if (!missing(`order`)) {
        body <- `order`$toJSONString()
      } else {
        body <- NULL
      }

      url_path <- "/store/order"

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "POST",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "Order", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response", .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg, .subclass = "ApiException", ApiException = ApiException$new(http_response = resp))
      }
    }
  )
)
